# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/jboss/ejb3/jboss-ejb3-vfs/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag alpha-1
%define namedversion %{version}-%{reltag}

Name:           jboss-ejb3-vfs
Version:        1.0.0
Release:        0.alpha1.0.3%{?dist}
Epoch:          0
Summary:        JBoss EJB 3.x VFS Abstraction Aggregator
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn co http://anonsvn.jboss.org/repos/jbossas/projects/ejb3/components/vfs/tags/1.0.0-alpha-1/ jboss-ejb3-vfs-1.0.0 && tar cjf jboss-ejb3-vfs-1.0.0.tar.bz2 jboss-ejb3-vfs-1.0.0
Source0:        jboss-ejb3-vfs-1.0.0.tar.bz2
Source1:        jboss-ejb3-vfs-jpp-depmap.xml
Source2:        jboss-ejb3-vfs-settings.xml
Source3:        jboss-ejb3-vfs-component-info.xml
Patch0:         jboss-ejb3-vfs-pom.patch
Patch1:         jboss-ejb3-vfs-build-pom.patch
Patch2:         jboss-ejb3-vfs-impl-vfs2-pom.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       java >= 0:1.6.0
Requires:       jboss-metadata >= 0:1.0.2
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jboss-metadata >= 0:1.0.2
%if 0
Requires:       jboss-parent >= 0:4
%endif
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:	maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-enforcer-rule-api
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-release-plugin
BUildRequires:  maven-site-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  codehaus-stax-api
BuildRequires:	jboss-parent >= 0:4
BuildRequires:  jboss-test >= 0:1.1.4
BuildRequires:  jbossws-spi >= 0:1.0.3
# org.jboss.ws.native:jbossws-native-jaxrpc:jar:3.0.4.GA for org.jboss.javaee:jboss-ejb-api:jar:3.0.0.GA
# jboss.jbossws:jboss-jaxws:jar:3.0.1-native-2.0.4.GA for org.jboss.metadata:jboss-metadata:jar:1.0.2.GA
BuildRequires:  jbossws >= 0:3.0.1
# 2.1.3.SP1
BuildRequires:  jboss-vfs2 >= 0:2.1.3
# XXX: >= 0:4.6
BuildRequires:  junit4 
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss EJB 3.x Virtual File System Abstraction Aggregator.

%package build
Summary:        JBoss EJB 3.x VFS Abstraction Build Parent
Group:          Development/Java
Requires:       jboss-parent >= 0:4
# XXX: >= 0:4.6
Requires:       junit4 >= 0:4.5

%description build
JBoss EJB 3.x Virtual File System Abstraction Build Parent.

%package impl-vfs2
Summary:        JBoss EJB 3.x VFS Abstraction Implementation for JBoss VFS2
Group:          Development/Java
# XXX: pom does not have this as parent
Requires:       %{name} = %{epoch}:%{version}-%{release}
%if 0
Requires:       %{name}-build = %{epoch}:%{version}-%{release}
%endif
Requires:       %{name}-spi = %{epoch}:%{version}-%{release}
Requires:       jboss-vfs2 >= 0:2.1.3
Requires:       jboss-metadata >= 0:1.0.2

%description impl-vfs2
JBoss EJB 3.x Virtual File System Abstraction Implementation for JBoss VFS2.

%package impl-vfs2-javadoc
Summary:        Javadoc for JBoss EJB 3.x VFS Abstraction Implementation for JBoss VFS2
Group:          Development/Java

%description impl-vfs2-javadoc
%{summary}.

%package spi
Summary:        JBoss EJB 3.x VFS Abstraction SPI
Group:          Development/Java
# XXX: pom does not have this as parent
Requires:       %{name} = %{epoch}:%{version}-%{release}
%if 0
Requires:       %{name}-build = %{epoch}:%{version}-%{release}
%endif
Requires:       jbossws-spi >= 0:1.0.3

%description spi
JBoss EJB 3.x Virtual File System Abstraction Service Provider Interface.

%package spi-javadoc
Summary:        Javadoc for JBoss EJB 3.x VFS Abstraction SPI
Group:          Development/Java

%description spi-javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
export JAVA_HOME=%{java_home}
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        -Dmaven.test.skip=true \
        deploy javadoc:javadoc

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
cp -p spi/target/jboss-ejb3-vfs-spi-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-spi-%{version}.jar
cp -p spi/target/jboss-ejb3-vfs-spi-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-spi-sources-%{version}.jar
cp -p impl-vfs2/target/jboss-ejb3-vfs-impl-vfs2-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-impl-vfs2-%{version}.jar
cp -p impl-vfs2/target/jboss-ejb3-vfs-impl-vfs2-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-impl-vfs2-sources-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -s ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{version}||g"`; done)

# pom
mkdir -p %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
%add_to_maven_depmap org.jboss.ejb3.vfs jboss-ejb3-vfs-parent %{namedversion} JPP %{name}-parent
%{__cp} -p build/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-build.pom
%add_to_maven_depmap org.jboss.ejb3.vfs jboss-ejb3-vfs-build %{namedversion} JPP %{name}-build
%{__cp} -p impl-vfs2/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-impl-vfs2.pom
%add_to_maven_depmap org.jboss.ejb3.vfs jboss-ejb3-vfs-impl-vfs2 %{namedversion} JPP %{name}-impl-vfs2
%if 0
%{__cp} -p impl-vfs3/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-impl-vfs3.pom
%add_to_maven_depmap org.jboss.ejb3.vfs jboss-ejb3-vfs-impl-vfs3 %{namedversion} JPP %{name}-impl-vfs3
%endif
%{__cp} -p spi/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-spi.pom
%add_to_maven_depmap org.jboss.ejb3.vfs jboss-ejb3-vfs-spi %{namedversion} JPP %{name}-spi

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-spi-%{version}
cp -pr spi/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-spi-%{version}
ln -s %{name}-spi-%{version} %{buildroot}%{_javadocdir}/%{name}-spi
mkdir -p %{buildroot}%{_javadocdir}/%{name}-impl-vfs2-%{version}
cp -pr impl-vfs2/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-impl-vfs2-%{version}
ln -s %{name}-impl-vfs2-%{version} %{buildroot}%{_javadocdir}/%{name}-impl-vfs2

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
mkdir -p %{buildroot}%{repodir}
mkdir -p %{buildroot}%{repodirlib}
install -p -m 755 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{version}-brew`
sed -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
mkdir -p %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH1} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH2} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-parent.pom %{buildroot}%{repodirlib}/jboss-ejb3-vfs-parent.pom
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-build.pom %{buildroot}%{repodirlib}/jboss-ejb3-vfs-build.pom
cp -p %{buildroot}%{_javadir}/%{name}-impl-vfs2-%{version}.jar %{buildroot}%{repodirlib}/jboss-ejb3-vfs-impl-vfs2.jar
cp -p %{buildroot}%{_javadir}/%{name}-impl-vfs2-sources-%{version}.jar %{buildroot}%{repodirlib}/jboss-ejb3-vfs-impl-vfs2-sources.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-impl-vfs2.pom %{buildroot}%{repodirlib}/jboss-ejb3-vfs-impl-vfs2.pom
cp -p %{buildroot}%{_javadir}/%{name}-spi-%{version}.jar %{buildroot}%{repodirlib}/jboss-ejb3-vfs-spi.jar
cp -p %{buildroot}%{_javadir}/%{name}-spi-sources-%{version}.jar %{buildroot}%{repodirlib}/jboss-ejb3-vfs-spi-sources.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-spi.pom %{buildroot}%{repodirlib}/jboss-ejb3-vfs-spi.pom
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
%{_mavendepmapfragdir}/%{name}

%files build
%defattr(0644,root,root,0755)
%{_datadir}/maven2/poms/JPP-%{name}-build.pom

%files impl-vfs2
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-impl-vfs2-%{version}.jar
%{_javadir}*/%{name}-impl-vfs2.jar
%{_javadir}*/%{name}-impl-vfs2-sources-%{version}.jar
%{_javadir}*/%{name}-impl-vfs2-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}-impl-vfs2.pom

%files impl-vfs2-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-impl-vfs2-%{version}
%{_javadocdir}/%{name}-impl-vfs2

%files spi
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-spi-%{version}.jar
%{_javadir}*/%{name}-spi.jar
%{_javadir}*/%{name}-spi-sources-%{version}.jar
%{_javadir}*/%{name}-spi-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}-spi.pom

%files spi-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-spi-%{version}
%{_javadocdir}/%{name}-spi

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Nov 29 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-0.alpha1.0.3
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR codehaus-stax-api, maven-site-plugin

* Wed Jun 02 2010 David Walluck <dwalluck@redhat.com> 0:1.0.0-0.alpha1.0.2
- fix depmap entries

* Tue Jun 01 2010 David Walluck <dwalluck@redhat.com> 0:1.0.0-0.alpha1.0.1
- 1.0.0-alpha-1
